;; (c) 2000 darkewolf

(require 'make-theme)

(let
    ((patterns-alist
      '(("right-border"
         (inactive
          "right_border-inactive.png")
         (focused
          "right_border.png")
         (highlighted
          "right_border.png")
         (inactive-highlighted
          "right_border.png")
         (clicked
          "right_border.png")
         (inactive-clicked
          "right_border.png"))
        ("title"
         (inactive
          "title-inactive.png")
         (focused
          "title.png")
         (highlighted
          "title.png")
         (clicked
          "title.png"))
        ("top-border"
         (inactive
          "top-border-inactive.png")
         (focused
          "top-border.png")
         (highlighted
          "top-border.png")
         (clicked
          "top-border.png"))
        ("bottom-border"
         (inactive
          "bottom-border-inactive.png")
         (focused
          "bottom-border.png")
         (highlighted
          "bottom-border.png")
         (clicked
          "bottom-border.png"))
        ("maximize-button"
         (inactive
          "maximize-button-inactive.png")
         (focused
          "maximize-button.png")
         (highlighted
          "maximize-button.png")
         (clicked
          "maximize-button.png"))
        ("iconify-button"
         (inactive
          "iconify-button-inactive.png")
         (focused
          "iconify-button.png")
         (highlighted
          "iconify-button.png")
         (clicked
          "iconify-button.png"))
        ("close-button"
         (inactive
          "close-button-inactive.png")
         (focused
          "close-button.png")
         (highlighted
          "close-button.png")
         (clicked
          "close-button.png"))
        ("left_border"
         (inactive
          "left_border-inactive.png")
         (focused
          "left_border.png")
         (highlighted
          "left_border.png")
         (clicked
          "left_border.png"))
        ("top-right-corner"
         (inactive
          "top-right-corner-inactive.png")
         (focused
          "top-right-corner.png")
         (highlighted
          "top-right-corner.png")
         (clicked
          "top-right-corner.png"))
        ("bottom-right-corner"
         (inactive
          "bottom-right-corner-inactive.png")
         (focused
          "bottom-right-corner.png")
         (highlighted
          "bottom-right-corner.png")
         (clicked
          "bottom-right-corner.png"))
        ("bottom-left-corner"
         (inactive
          "bottom-left-corner-inactive.png")
         (focused
          "bottom-left-corner.png")
         (highlighted
          "bottom-left-corner.png")
         (clicked
          "bottom-left-corner.png"))
        ("top-left-corner"
         (inactive
          "top-left-corner-inactive.png")
         (focused
          "top-left-corner.png")
         (highlighted
          "top-left-corner.png")
         (clicked
          "top-left-corner.png"))))

     (frames-alist
      '(("normal"
         ((top-edge . -12)
          (left-edge . -8)
          (background . "top-left-corner")
          (class . top-left-corner)
          (x-justify . center)
          (y-justify . center))
         ((left-edge . -8)
          (bottom-edge . -8)
          (background . "bottom-left-corner")
          (class . bottom-left-corner)
          (x-justify . center)
          (y-justify . center))
         ((right-edge . -8)
          (bottom-edge . -8)
          (background . "bottom-right-corner")
          (class . bottom-right-corner)
          (x-justify . center)
          (y-justify . center))
         ((top-edge . -20)
          (right-edge . -8)
          (background . "top-right-corner")
          (class . top-right-corner)
          (x-justify . center)
          (y-justify . center))
         ((top-edge . 0)
          (left-edge . -8)
          (bottom-edge . 0)
          (background . "left_border")
          (class . left-border)
          (x-justify . center)
          (y-justify . center))
         ((top-edge . -16)
          (right-edge . 1)
          (background . "close-button")
          (class . close-button)
          (x-justify . center)
          (y-justify . center))
         ((right-edge . 13)
          (top-edge . -16)
          (background . "iconify-button")
          (class . iconify-button)
          (x-justify . center)
          (y-justify . center))
         ((y-justify . top)
          (right-edge . 23)
          (top-edge . -16)
          (background . "maximize-button")
          (class . maximize-button)
          (x-justify . center))
         ((below-client . t)
          (bottom-edge . -8)
          (left-edge . 0)
          (right-edge . 0)
          (background . "bottom-border")
          (class . bottom-border)
          (x-justify . center)
          (y-justify . center))
         ((left-edge . 0)
          (top-edge . -20)
          (background . "top-border")
          (class . top-border)
          (y-justify . center)
          (foreground . "#000000"))
         ((left-edge . 72)
          (right-edge . 34)
          (top-edge . -20)
          (foreground . "#01f001f001f0")
          (y-justify . -15)
          (x-justify . center)
          (background . "title")
          (class . title)
          (text . window-name))
         ((y-justify . 3)
          (right-edge . -8)
          (top-edge . 0)
          (bottom-edge . 0)
          (background . "right-border")
          (class . right-border)))
        ("shaped"
         ((top-edge . 8)
          (left-edge . 0)
          (background . "top-left-corner")
          (class . top-left-corner)
          (x-justify . center)
          (y-justify . center))
         ((background . "bottom-left-corner")
          (left-edge . 0)
          (bottom-edge . 0)
          (class . bottom-left-corner)
          (x-justify . center)
          (y-justify . center))
         ((background . "bottom-right-corner")
          (right-edge . 0)
          (bottom-edge . 0)
          (class . bottom-right-corner)
          (x-justify . center)
          (y-justify . center))
         ((background . "top-right-corner")
          (right-edge . 0)
          (top-edge . 0)
          (class . top-right-corner)
          (x-justify . center)
          (y-justify . center))
         ((background . "left_border")
          (left-edge . 0)
          (top-edge . 20)
          (bottom-edge . 10)
          (class . left-border)
          (x-justify . center)
          (y-justify . center))
         ((background . "close-button")
          (right-edge . 9)
          (top-edge . 4)
          (class . close-button)
          (x-justify . center)
          (y-justify . center))
         ((background . "iconify-button")
          (right-edge . 21)
          (top-edge . 4)
          (class . iconify-button)
          (x-justify . center)
          (y-justify . center))
         ((background . "maximize-button")
          (right-edge . 31)
          (top-edge . 4)
          (class . maximize-button)
          (x-justify . center)
          (y-justify . center))
         ((background . "bottom-border")
          (left-edge . 11)
          (right-edge . 10)
          (bottom-edge . 0)
          (class . bottom-border)
          (x-justify . center)
          (y-justify . center))
         ((background . "top-border")
          (left-edge . 9)
          (top-edge . 0)
          (bottom-edge . 36)
          (class . top-border)
          (y-justify . center)
          (foreground . "#000000"))
         ((background . "title")
          (left-edge . 81)
          (right-edge . 42)
          (top-edge . 0)
          (class . title)
          (font . fixed)
		  (text . window-name)
          (x-justify . center)
          (y-justify . center)
          (foreground . "#000000")))
        ("transient")
        ("shaped-transient")))

     (mapping-alist
      '((default . "normal")
        (transient . "transient")
        (shaped . "shaped")
        (shaped-transient . "shaped-transient")
        (unframed . "nil")))

     (theme-name 'Vision))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))
